﻿using System;
using System.Collections.Generic;
 
using System.Text;
using System.Windows.Forms;

using Autodesk.Navisworks.Api;
using Autodesk.Navisworks.Api.Plugins;

namespace NetAddIn_CS
{
    [PluginAttribute("NetAddIn-CS",                   //Plugin name
                  "ADSK",                                       //4 character Developer ID or GUID
                  ToolTip = "NetAddIn-CS.Class1 tool tip",//The tooltip for the item in the ribbon
                  DisplayName = "NetAddIn-CS.Class1")]          //Display name for the Plugin in the Ribbon

    [AddInPluginAttribute(AddInLocation.AddIn)]
  
    public class Class1 : AddInPlugin  
    {
        public override int Execute(params string[] parameters)
        {
            String flag = string.Empty;

            //Iterate the parameters and build the complete message
            foreach (String param in parameters)
            {
                flag += param;
            }

            
            if (flag == "NetAuto-CS")
            {
                //be used from sample NetAuto-CS
                MessageBox.Show("NetAddIn-CS Add-in");
            }
            else
            {
               
                //please open the sample model gatehouse.nwd in <Navisworks Installation path>\api folder
                Document doc = Autodesk.Navisworks.Api.Application.ActiveDocument;

                Search search = new Search();
                search.Selection.SelectAll();

                search.SearchConditions.Add(SearchCondition.HasPropertyByDisplayName("Entity Handle", "Value").EqualValue(VariantData.FromDisplayString ("16C17"))); 

                ModelItemCollection items = search.FindAll(doc, false);
 

                doc.CurrentSelection.CopyFrom(items);

                foreach (ModelItem oMI in items)
                {
                    PropertyCategory oPC = oMI.PropertyCategories.FindCategoryByName(PropertyCategoryNames.Item);
                    if (oPC != null)
                    {
                        DataProperty oDP = oPC.Properties.FindPropertyByName(DataPropertyNames.ItemLayer );
                        if (oDP != null)
                        {
                            MessageBox.Show(oDP.Value.ToDisplayString());
                        }
                    }                   
                 
                }
            }



            return 0;
        }
    }
}
